<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" :inline="true" v-show="showSearch" label-width="90px">
      <el-form-item label="组合码" prop="barCode">
        <el-input
          v-model="queryParams.barCode"
          placeholder="请输入组合码"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="组合名称" prop="groupName">
        <el-input
          v-model="queryParams.groupName"
          placeholder="请输入名称"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item>
        <el-button type="cyan" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          icon="el-icon-plus"
          size="mini"
          @click="handleAdd"
          v-hasPermi="['store:storeProductGroup:add']"
        >新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="success"
          icon="el-icon-edit"
          size="mini"
          :disabled="single"
          @click="handleUpdate"
          v-hasPermi="['store:storeProductGroup:edit']"
        >修改</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="danger"
          icon="el-icon-delete"
          size="mini"
          :disabled="multiple"
          @click="handleDelete"
          v-hasPermi="['store:storeProductGroup:remove']"
        >删除</el-button>
      </el-col>
	  <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table  height="500" border v-loading="loading" :data="storeProductGroupList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="ID" align="center" prop="groupId" />
      <el-table-column label="组合名称" align="center" prop="groupName" />
      <el-table-column label="组合码" align="center" prop="barCode" />
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleUpdate(scope.row)"
            v-hasPermi="['store:storeProductGroup:edit']"
          >修改</el-button>
          <el-button
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleDelete(scope.row)"
            v-hasPermi="['store:storeProductGroup:remove']"
          >删除</el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改商品组合对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="1000px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="组合名称" prop="groupName">
          <el-input v-model="form.groupName" placeholder="请输入商品组合名称" />
        </el-form-item>
        <el-form-item label="组合码" prop="barCode">
          <el-input v-model="form.barCode" placeholder="请输入商品组合码" />
        </el-form-item>
        <el-form-item label="商品" prop="productList"  >
          <el-row  >
            <el-col >
                  <el-button plain  type="primary" icon="el-icon-plus" @click="handleAddProduct">添加商品</el-button>
            </el-col>
          </el-row>
          <el-table border width="100%" style="margin-top:5px;"  :data="products">
            <el-table-column label="商品编号" align="center" prop="barCode" />
            <el-table-column label="商品图片" align="center" width="100">
              <template slot-scope="scope">
                <el-popover
                  placement="right"
                  title=""
                  trigger="hover"
                >
                  <img slot="reference" :src="scope.row.image" width="50">
                  <img :src="scope.row.image" style="max-width: 50px;">
                </el-popover>
              </template>
            </el-table-column>
            <el-table-column label="商品名称" show-overflow-tooltip align="center" prop="productName" />
            <el-table-column label="商品规格" align="center" prop="sku" />
            <!-- <el-table-column label="库存" align="center" prop="stock" /> -->
            <el-table-column label="售价" align="center"  prop="price"  >
              <template slot-scope="scope">
                <div v-if="scope.row.price!=null">
                    {{scope.row.price.toFixed(2)}}
                </div>
              </template>
            </el-table-column>
            <el-table-column label="数量" align="center"  prop="count" width="200px" >
              <template slot-scope="scope">
                <div>
                    <el-input-number v-model="scope.row.count"  @change="handleProductCountChange(scope.row)"  size="mini" :min="1" :max="scope.row.stock"  ></el-input-number>
                </div>
              </template>
            </el-table-column>
            <el-table-column label="操作" align="center" width="100px" >
              <template slot-scope="scope">
                <el-button
                  size="mini"
                  type="text"
                  icon="el-icon-delete"
                  @click="handleProductDelete(scope.row)"
                >删除</el-button>
              </template>
            </el-table-column>
          </el-table>
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
    <el-dialog :title="product.title" v-if="product.open"  :visible.sync="product.open" width="1000px" append-to-body>
        <product-attr-value-select  ref="product"  @selectProduct="selectProduct" />
    </el-dialog>
  </div>
</template>

<script>
import { listStoreProductGroup, getStoreProductGroup, delStoreProductGroup, addStoreProductGroup, updateStoreProductGroup, exportStoreProductGroup } from "@/api/hisStore/storeProductGroup";
import productAttrValueSelect from "../components/productAttrValueSelect";
export default {
  name: "HisStoreProductGroup",
  components: {
    productAttrValueSelect,
  },
  data() {
    return {
      products:[],
      product:{
        open:false,
        title:"商品选择"
      },
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 商品组合表格数据
      storeProductGroupList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        productId: null,
        barCode: null,
        groupName: null
      },
      // 表单参数
      form: {
        productList:null,
      },
      // 表单校验
      rules: {
        groupName: [
          { required: true, message: "组合名称不能为空" }
        ],
        barCode: [
          { required: true, message: "组合码不能为空" }
        ],
        productList: [
          { required: true, message: "商品不能为空" }
        ],
      }
    };
  },
  created() {
    this.getList();
  },
  methods: {
    handleProductCountChange(row){
      row.money=row.count*row.price;
      this.$forceUpdate();
    },
    handleProductDelete(row){
       this.products.splice(this.products.findIndex(item => item.id === row.id), 1)
    },
    selectProduct(row){
      for(var i=0;i<this.products.length;i++){
        if(this.products[i].id==row.id){
          return;
        }
      }
      this.products.push(row);
    },
    handleAddProduct(){
      this.product.open=true;

    },
    /** 查询商品组合列表 */
    getList() {
      this.loading = true;
      listStoreProductGroup(this.queryParams).then(response => {
        this.storeProductGroupList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        groupId: null,
        productList: null,
        barCode: null,
        groupName: null
      };
      this.products=[];
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.groupId)
      this.single = selection.length!==1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加商品组合";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const groupId = row.groupId || this.ids
      getStoreProductGroup(groupId).then(response => {
        this.form = response.data;
        this.products=this.form.productList;
        this.open = true;
        this.title = "修改商品组合";
        this.$forceUpdate();
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.form.productList=[];
      this.products.forEach((item) => {
        var data={id:item.id,count:item.count}
        this.form.productList.push(data)
      })
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.groupId != null) {
            updateStoreProductGroup(this.form).then(response => {
              if (response.code === 200) {
                this.msgSuccess("修改成功");
                this.open = false;
                this.getList();
              }
            });
          } else {
            addStoreProductGroup(this.form).then(response => {
              if (response.code === 200) {
                this.msgSuccess("新增成功");
                this.open = false;
                this.getList();
              }
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const groupIds = row.groupId || this.ids;
      this.$confirm('是否确认删除商品组合编号为"' + groupIds + '"的数据项?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(function() {
          return delStoreProductGroup(groupIds);
        }).then(() => {
          this.getList();
          this.msgSuccess("删除成功");
        }).catch(function() {});
    },
    /** 导出按钮操作 */
    handleExport() {
      const queryParams = this.queryParams;
      this.$confirm('是否确认导出所有商品组合数据项?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(function() {
          return exportStoreProductGroup(queryParams);
        }).then(response => {
          this.download(response.msg);
        }).catch(function() {});
    }
  }
};
</script>
